Index: pjproject/main/pjlib/build/pjlib.dsp
===================================================================
--- pjproject/main/pjlib/build/pjlib.dsp	(revision 10)
+++ pjproject/main/pjlib/build/pjlib.dsp	(revision 11)
@@ -392,4 +392,8 @@
 # Begin Source File
 
+SOURCE=..\include\pj\compat\os_sunos.h
+# End Source File
+# Begin Source File
+
 SOURCE=..\include\pj\compat\os_win32.h
 # End Source File
Index: pjproject/main/pjlib/build/pjlib_test.dsp
===================================================================
--- pjproject/main/pjlib/build/pjlib_test.dsp	(revision 10)
+++ pjproject/main/pjlib/build/pjlib_test.dsp	(revision 11)
@@ -197,4 +197,8 @@
 # Begin Source File
 
+SOURCE="..\src\pjlib-test\udp_echo_srv_ioqueue.c"
+# End Source File
+# Begin Source File
+
 SOURCE="..\src\pjlib-test\udp_echo_srv_sync.c"
 # End Source File
Index: pjproject/main/pjlib/include/pj/compat/os_linux.h
===================================================================
--- pjproject/main/pjlib/include/pj/compat/os_linux.h	(revision 10)
+++ pjproject/main/pjlib/include/pj/compat/os_linux.h	(revision 11)
@@ -57,4 +57,19 @@
 #define PJ_SOCK_HAS_INET_ATON	    1
 
+/* When this macro is set, getsockopt(SOL_SOCKET, SO_ERROR) will return
+ * the status of non-blocking connect() operation.
+ */
+#define PJ_HAS_SO_ERROR             1
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket recv() can not return immediate daata.
+ */
+#define PJ_BLOCKING_ERROR_VAL       EAGAIN
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket connect() can not get connected immediately.
+ */
+#define PJ_BLOCKING_CONNECT_ERROR_VAL   EINPROGRESS
+
 /* Default threading is enabled, unless it's overridden. */
 #ifndef PJ_HAS_THREADS
Index: pjproject/main/pjlib/include/pj/compat/os_linux_kernel.h
===================================================================
--- pjproject/main/pjlib/include/pj/compat/os_linux_kernel.h	(revision 10)
+++ pjproject/main/pjlib/include/pj/compat/os_linux_kernel.h	(revision 11)
@@ -54,4 +54,19 @@
 #define PJ_SOCK_HAS_INET_ATON	    0
 
+/* When this macro is set, getsockopt(SOL_SOCKET, SO_ERROR) will return
+ * the status of non-blocking connect() operation.
+ */
+#define PJ_HAS_SO_ERROR             1
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket recv() can not return immediate daata.
+ */
+#define PJ_BLOCKING_ERROR_VAL       EAGAIN
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket connect() can not get connected immediately.
+ */
+#define PJ_BLOCKING_CONNECT_ERROR_VAL   EINPROGRESS
+
 #ifndef PJ_HAS_THREADS
 #  define PJ_HAS_THREADS	    (1)
Index: pjproject/main/pjlib/include/pj/compat/os_palmos.h
===================================================================
--- pjproject/main/pjlib/include/pj/compat/os_palmos.h	(revision 10)
+++ pjproject/main/pjlib/include/pj/compat/os_palmos.h	(revision 11)
@@ -46,4 +46,19 @@
 #define PJ_SOCK_HAS_INET_ATON	    0
 
+/* When this macro is set, getsockopt(SOL_SOCKET, SO_ERROR) will return
+ * the status of non-blocking connect() operation.
+ */
+#define PJ_HAS_SO_ERROR             0
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket recv() can not return immediate daata.
+ */
+#define PJ_BLOCKING_ERROR_VAL       xxx
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket connect() can not get connected immediately.
+ */
+#define PJ_BLOCKING_CONNECT_ERROR_VAL   xxx
+
 /* Default threading is enabled, unless it's overridden. */
 #ifndef PJ_HAS_THREADS
Index: pjproject/main/pjlib/include/pj/compat/os_sunos.h
===================================================================
--- pjproject/main/pjlib/include/pj/compat/os_sunos.h	(revision 10)
+++ pjproject/main/pjlib/include/pj/compat/os_sunos.h	(revision 11)
@@ -41,4 +41,19 @@
 #define PJ_SOCK_HAS_INET_ATON	    0
 
+/* When this macro is set, getsockopt(SOL_SOCKET, SO_ERROR) will return
+ * the status of non-blocking connect() operation.
+ */
+#define PJ_HAS_SO_ERROR             0
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket recv() can not return immediate daata.
+ */
+#define PJ_BLOCKING_ERROR_VAL       EWOULDBLOCK
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket connect() can not get connected immediately.
+ */
+#define PJ_BLOCKING_CONNECT_ERROR_VAL   EINPROGRESS
+
 /* Default threading is enabled, unless it's overridden. */
 #ifndef PJ_HAS_THREADS
Index: pjproject/main/pjlib/include/pj/compat/os_win32.h
===================================================================
--- pjproject/main/pjlib/include/pj/compat/os_win32.h	(revision 10)
+++ pjproject/main/pjlib/include/pj/compat/os_win32.h	(revision 11)
@@ -61,4 +61,19 @@
 #define PJ_SOCK_HAS_INET_ATON	    0
 
+/* When this macro is set, getsockopt(SOL_SOCKET, SO_ERROR) will return
+ * the status of non-blocking connect() operation.
+ */
+#define PJ_HAS_SO_ERROR             0
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket recv() or send() can not return immediately.
+ */
+#define PJ_BLOCKING_ERROR_VAL       WSAEWOULDBLOCK
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket connect() can not get connected immediately.
+ */
+#define PJ_BLOCKING_CONNECT_ERROR_VAL   WSAEWOULDBLOCK
+
 /* Default threading is enabled, unless it's overridden. */
 #ifndef PJ_HAS_THREADS
Index: pjproject/main/pjlib/include/pj/doxygen.h
===================================================================
--- pjproject/main/pjlib/include/pj/doxygen.h	(revision 10)
+++ pjproject/main/pjlib/include/pj/doxygen.h	(revision 11)
@@ -89,6 +89,9 @@
  * <b>PJLIB Page Documentation</b> on navigation pane of your PDF reader.
  *
- *
- *
+ *  - <b>How to Submit Code to PJLIB Project</b>
+ *\n
+ * Please read \ref pjlib_coding_convention_page before submitting
+ * your code. Send your code as patch against current Subversion tree
+ * to the appropriate mailing list.
  *
  *
@@ -395,4 +398,50 @@
 
 
+
+/*////////////////////////////////////////////////////////////////////////// */
+/*
+         CODING CONVENTION
+ */
+
+/**
+ * @page pjlib_coding_convention_page Coding Convention
+ *
+ * Before you submit your code/patches to be included with PJLIB, you must
+ * make sure that your code is compliant with PJLIB coding convention.
+ * <b>This is very important!</b> Otherwise we would not accept your code.
+ *
+ * @section coding_conv_editor_sec Editor Settings
+ *
+ * The single most important thing in the whole coding convention is editor 
+ * settings. It's more important than the correctness of your code (bugs will
+ * only crash the system, but incorrect tab size is mental!).
+ *
+ * Kindly set your editor as follows:
+ *  - tab size to \b 8.
+ *  - indentation to \b 4.
+ *
+ * With \c vi, you can do it with:
+ * <pre>
+ *  :se ts=8
+ *  :se sts=4
+ * </pre>
+ *
+ * You should replace tab with eight spaces.
+ *
+ * @section coding_conv_detail_sec Coding Style
+ *
+ * Coding style MUST strictly follow K&R style. The rest of coding style
+ * must follow current style. You SHOULD be able to observe the style
+ * currently used by PJLIB from PJLIB sources, and apply the style to your 
+ * code. If you're not able to do simple thing like to observe PJLIB
+ * coding style from the sources, then logic dictates that your ability to
+ * observe more difficult area in PJLIB such as memory allocation strategy, 
+ * concurrency, etc is questionable.
+ *
+ * @section coding_conv_comment_sec Commenting Your Code
+ *
+ * Public API (e.g. in header files) MUST have doxygen compliant comments.
+ *
+ */
 
 
